DevExtreme jQuery/JS - Component Configuration Syntax

Create and Configure a Component

Any DevExtreme UI component must be placed in a container. This role is played by a <div> HTML element. Add a <div> to the <body> tag of your page. Make sure that this <div> has the id attribute specified.

HTML
  • <div id="buttonContainer"></div>

DevExtreme supplies a jQuery plugin for each UI component. To create, for example, the Button UI component within the buttonContainer element, use the dxButton() plugin as the following code shows.

JavaScript
  • $(function () {
  • $("#buttonContainer").dxButton();
  • });

To configure a UI component, pass an object to the plugin as shown in the following code. Properties of this object mirror the properties of the UI component.

JavaScript
  • $(function () {
  • $("#buttonContainer").dxButton({
  • text: "Click me!",
  • onClick: function () {
  • alert("Hello world!");
  • }
  • });
  • });
See Also

Get and Set Properties

All operations with UI component properties are carried out using the option() method. You can use it to do the following.

Get a Single Property

JavaScript
  • var dataGridInstance = $("#dataGridContainer").dxDataGrid("instance");
  • var dataSource = dataGridInstance.option("dataSource");
  • var editMode = dataGridInstance.option("editing.mode");
  •  
  • // ---------- or ----------
  • var dataSource = $("#dataGridContainer").dxDataGrid("option", "dataSource");
  • var editMode = $("#dataGridContainer").dxDataGrid("option", "editing.mode");

Get All Properties

JavaScript
  • var dataGridInstance = $("#dataGridContainer").dxDataGrid("instance");
  • var dataGridOptions = dataGridInstance.option();
  •  
  • // ---------- or ----------
  • var dataGridOptions = $("#dataGridContainer").dxDataGrid("option");

Set a Single Property

JavaScript
  • var dataGridInstance = $("#dataGridContainer").dxDataGrid("instance");
  • dataGridInstance.option("dataSource", []);
  • dataGridInstance.option("editing.mode", "batch");
  •  
  • // ---------- or ----------
  • $("#dataGridContainer").dxDataGrid("option", "dataSource", []);
  • $("#dataGridContainer").dxDataGrid("option", "editing.mode", "batch");
NOTE
If you perform several property changes, wrap them with the beginUpdate() and endUpdate() method calls. This prevents the UI component from being unnecessarily refreshed and from events being raised. Use an object instead if you need to change several properties at once.

Set Several Properties

JavaScript
  • var dataGridInstance = $("#dataGridContainer").dxDataGrid("instance");
  • dataGridInstance.option({
  • dataSource: [],
  • editing: {
  • mode: "cell"
  • }
  • });
  •  
  • // ---------- or ----------
  • $("#dataGridContainer").dxDataGrid({
  • dataSource: [],
  • editing: {
  • mode: "cell"
  • }
  • });
NOTE

When you pass an object to the option(options) method or to the jQuery plugin at runtime as shown in the previous code, properties specified in this object will be merged with the properties that were specified at design time.

This works properly unless the properties were specified as arrays. If the latter is true, set new properties between beginUpdate() and endUpdate() method calls. The following code sample demonstrates the described technique using an example of the valueAxis array in the Chart UI component:

JavaScript
  • var chart = $("#chartContainer").dxChart({
  • // ...
  • valueAxis: [{
  • name: "axis1",
  • // ...
  • }, {
  • name: "axis2",
  • // ...
  • }]
  • }).dxChart("instance");
  •  
  • chart.beginUpdate();
  • chart.option("valueAxis[0].visible", false);
  • chart.option("valueAxis[1].grid.visible", false);
  • chart.endUpdate();

Call Methods

To call a UI component method, pass its name to the jQuery plugin.

JavaScript
  • var allSeries = $("#chartContainer").dxChart("getAllSeries");

If a method accepts arguments, pass them right after the method's name.

JavaScript
  • var fruitsSeries = $("#chartContainer").dxChart("getSeriesByName", "fruits");

As an alternative, you can obtain the UI component instance first, and then call any method of this instance.

JavaScript
  • var chartInstance = $("#chartContainer").dxChart("instance");
  • var allSeries = chartInstance.getAllSeries();
  • var fruitsSeries = chartInstance.getSeriesByName("fruits");
See Also
  • API Reference.WidgetName.Methods, for example, API Reference.Chart.Methods

Get a UI Component Instance

Use the following code to get a UI component instance:

JavaScript
  • var chartInstance = $("#chartContainer").dxChart("instance");

If the UI component is not yet instantiated, this code throws an E0009 exception that you can handle with a try...catch block:

JavaScript
  • try {
  • var chartInstance = $("#chartContainer").dxChart("instance");
  • }
  • catch (err) {
  • alert("Exception handled: " + err.message);
  • }

Instead of the exception, you can get a truthy or falsy value that can be used in conditional statements. To do this, call the UI component class's static getInstance(element) method. This method returns undefined if the UI component is not instantiated for the element:

JavaScript
  • var element = document.getElementById("chartContainer");
  • var chartInstance = DevExpress.viz.dxChart.getInstance(element);
  • if (chartInstance) {
  • // Your code goes here
  • }

Handle Events

Subscribe to an Event

You can subscribe to an event using a configuration property. All event handling properties are given names that begin with on.

JavaScript
  • $("#dataGridContainer").dxDataGrid({
  • onCellClick: function (e) {
  • // Handles the "cellClick" event
  • },
  • onSelectionChanged: function (e) {
  • // Handles the "selectionChanged" event
  • }
  • });

As a more flexible solution, you can use the on() method. It allows you to subscribe to events at runtime and attach several handlers to a single event.

JavaScript
  • var dataGridInstance = $("#dataGridContainer").dxDataGrid("instance");
  • // Subscribes to the "cellClick" and "selectionChanged" events
  • dataGridInstance
  • .on({
  • "cellClick": cellClickHandler,
  • "selectionChanged": selectionChangedHandler
  • });
JavaScript
  • var dataGridInstance = $("#dataGridContainer").dxDataGrid("instance");
  • // Attaches several handlers to the "cellClick" event
  • dataGridInstance
  • .on("cellClick", cellClickHandler1)
  • .on("cellClick", cellClickHandler2);

Unsubscribe from an Event

To detach a specific handler from an event, call the off(eventName, handler) method.

JavaScript
  • var dataGridInstance = $("#dataGridContainer").dxDataGrid("instance");
  • // Detaches the "cellClickHandler1" from the "cellClick" event leaving other handlers (if any) intact
  • dataGridInstance.off("cellClick", cellClickHandler1)

You can also use this method to detach all handlers from a particular event.

JavaScript
  • var dataGridInstance = $("#dataGridContainer").dxDataGrid("instance");
  • // Detaches all handlers from the "cellClick" event
  • dataGridInstance.off("cellClick")

If you subscribed to an event using an onEventName property, you can unsubscribe from it by setting this property to undefined.

JavaScript
  • var dataGridInstance = $("#dataGridContainer").dxDataGrid("instance");
  • dataGridInstance.option("onCellClick", undefined);
See Also
  • API Reference.WidgetName.Events, for example, API Reference.DataGrid.Events

Dispose of a UI Component

To dispose of a DevExtreme UI component, free up the allocated resources by calling the dispose() method. Then, remove the UI component's associated DOM node:

JavaScript
  • $("#dataGridContainer").dxDataGrid("dispose");
  • $("#dataGridContainer").remove();

Properties of the Object Type
Use UI components prefixed with dxo-
("o" stands for "object"). In the following example, we configure the TreeMap's tooltip property:
<dx-tree-map> <dxo-tooltip [enabled]="true" format="thousands"> </dxo-tooltip> </dx-tree-map>
Particular properties of the object type are not implemented as nested components. These properties depend on the values of other properties and therefore cannot be typed (columns[].editorOptions in the DataGrid, item's editorOptions in the Form, items[].options in the Toolbar). Specify them with an object:
<dx-data-grid> <dxi-column [editorOptions]="{ width: 100 }"> </dxi-column> </dx-data-grid>
Collections
Use UI components prefixed with dxi-
("i" stands for "item"). The following example shows how to configure the DataGrid's columns property:
<dx-data-grid> <dxi-column dataField="firstName" caption="First Name"></dxi-column> <dxi-column dataField="lastName" caption="Last Name" [visible]="false"></dxi-column> </dx-data-grid>
For properties that accept either an object or a collection, use UI components prefixed with dxi-
as well. The series and valueAxis properties in the Chart UI component exemplify this case:
<dx-chart> <dxi-series valueField="value" argumentField="argument"></dxi-series> <dxi-value-axis> <dxo-label format="millions"></dxo-label> </dxi-value-axis> </dx-chart>
A special dxi-
element, dxi-item
, is designed to declare items in collection UI components. It supports structural directives provided by Angular, for instance, ngFor
. The following code shows how to use dxi-item
to declare items in the List UI component.
dxi-item
also supports directives that control parts of item appearance, such as badge
in the code below. They are described in the items section of each collection UI component.
<dx-list> <dxi-item> <h1>Available items</h1> </dxi-item> <dxi-item *ngFor="let item of listItems" [badge]="item.badge"> <h2>{{item.text}}</h2> </dxi-item> </dx-list>
// ... export class AppComponent { listItems = [{ text: 'Cars', badge: '12' }, { text: 'Bikes', badge: '5' }]; }
If a dxi-item
contains nested components, wrap the content in an element with the dxTemplate
directive without parameters:
<dx-list> <dxi-item> <div *dxTemplate> <dx-button text="I am a nested component"></dx-button> </div> </dxi-item> </dx-list>
Event Handling
<dx-button text="OK" (onClick)="okClicked($event)"> </dx-button>
import notify from "devextreme/ui/notify"; // ... export class AppComponent { okClicked (e) { notify("The OK button was clicked") } }
In nested components, the ()
syntax cannot be used. Use the []
syntax instead:
<dx-data-grid> <dxi-column type="buttons"> <dxi-button [onClick]="okClicked"> </dxi-button> </dxi-column> </dx-data-grid>
import notify from "devextreme/ui/notify"; // ... export class AppComponent { okClicked (e) { notify("The OK button was clicked") } }
Callback Functions
<dx-vector-map> <dxi-layer [customize]="customizeLayers"> </dxi-layer> </dx-vector-map>
// ... export class AppComponent { customizeLayers(elements) { // ... } }
Callback functions are executed outside the component's context. If the context is important, explicitly bind the callback function to it in the constructor.
// ... export class AppComponent { myCountry: string = "USA"; // we need to access this context variable in the callback function constructor() { this.customizeLayers = this.customizeLayers.bind(this); } customizeLayers(elements) { let country = this.myCountry; // ... } }
<dx-vector-map> <dxi-layer [customize]="customizeLayers"> </dxi-layer> </dx-vector-map>
One-Way Property Binding
Changes in the bindingProperty
are propagated to the TextBox's value, but not vice versa:
<dx-text-box [value]="bindingProperty"></dx-text-box>
// ... export class AppComponent { bindingProperty: string = "Some value"; }
Two-Way Property Binding
Changes in the bindingProperty
are propagated to the TextBox's value and vice versa:
<dx-text-box [(value)]="bindingProperty"></dx-text-box>
// ... export class AppComponent { bindingProperty: string = "Some value"; }
Declare Content in the Markup
The following UI components allow you to declare their content directly in the markup:
The following is an example with ScrollView:
<dx-scroll-view> <div>Some scrollable content</div> </dx-scroll-view>
Templates
Templates allow you to customize UI component elements. In the following code, an itemTemplate called listItem
and a groupTemplate called listGroup
customize items and groups in the List. Inside the templates, the itemData
and groupData
variables expose item and group data objects; the itemIndex
variable gives access to the item index.
<dx-list [items]="groupedItems" [grouped]="true" itemTemplate="listItem" groupTemplate="listGroup"> <div *dxTemplate="let itemData of 'listItem'; let itemIndex = index"> {{itemIndex}} - {{itemData.itemProperty}} </div> <div *dxTemplate="let groupData of 'listGroup'"> {{groupData.groupProperty}} </div> </dx-list>
dxTemplate
attribute directive cannot be used on custom markup elements. Refer to the common Custom Templates article for more information.
Angular has a built-in template
directive. This causes an error when you try to specify an eponymous property on a configuration component (for instance, on dxo-master-detail
). In this case, use the following syntax:
<dxo-master-detail [template]="'masterDetail'"></dxo-master-detail>
External Templates
External templates are created using the ng-template
element. The following code replicates the example above, but here the itemTemplate is the external template. The groupTemplate is omitted.
The ngTemplateOutlet
directive uses a template reference variable to reference the external template. The ngTemplateOutletContext
directive specifies variables that are accessible in the template.
<dx-list [items]="items" itemTemplate="listItem"> <div *dxTemplate="let itemData of 'listItem'; let itemIndex = index"> <ng-template [ngTemplateOutlet]="customItemTemplate" [ngTemplateOutletContext]="{ itemData: itemData, itemIndex: itemIndex }"> </ng-template> </div> </dx-list> <ng-template #customItemTemplate let-data="itemData" let-index="itemIndex"> {{index}} - {{data.itemProperty}} </ng-template>
In the previous code, the external template is used in the same component in which it is declared. The following code illustrates the case when the external template is declared in another component. The ngTemplateOutlet
directive should be set to an input property in this case:
<ng-template #customItemTemplate let-data="itemData" let-index="itemIndex"> {{index}} - {{data.itemProperty}} </ng-template> <custom-list [externalItemTemplate]="customItemTemplate"> </custom-list>
<dx-list ... itemTemplate="listItem"> <div *dxTemplate="let itemData of 'listItem'; let itemIndex = index"> <ng-template [ngTemplateOutlet]="externalItemTemplate" [ngTemplateOutletContext]="{ itemData: itemData, itemIndex: itemIndex }"> </ng-template> </div> </dx-list>
import { Component, Input, TemplateRef } from '@angular/core'; @Component({ selector: 'custom-list', templateUrl: './custom-list.component.html' }) export class CustomListComponent { @Input() externalItemTemplate: TemplateRef<any> // ... }
Call Methods
To call UI component methods, you need its instance. To access it, use the @ViewChild
or @ViewChildren
decorator (depending on whether you are getting a single or multiple UI component instances) and the component's instance
property. These decorators accept a component name or a template reference variable. The following code illustrates this approach by the example of the DataGrid:
import { Component, ViewChild } from "@angular/core"; import { DxDataGridComponent } from "devextreme-angular"; // ... export class AppComponent { @ViewChild(DxDataGridComponent, { static: false }) dataGrid: DxDataGridComponent // ===== or using a template reference variable ===== @ViewChild("targetDataGrid", { static: false }) dataGrid: DxDataGridComponent // Prior to Angular 8 // @ViewChild(DxDataGridComponent) dataGrid: DxDataGridComponent // @ViewChild("targetDataGrid") dataGrid: DxDataGridComponent refresh() { this.dataGrid.instance.refresh(); } // Getting multiple instances of one UI component // @ViewChildren(DxDataGridComponent) dataGrids: QueryList<DxDataGridComponent> }
<dx-data-grid #targetDataGrid [dataSource]="dataSource"></dx-data-grid> <dx-button text="Refresh data" (onClick)="refresh()"></dx-button>
Alternatively, you can assign the UI component instance to a variable and use it to call the methods:
<dx-data-grid [dataSource]="dataSource" (onInitialized)="saveGridInstance($event)"> </dx-data-grid> <dx-button text="Refresh data" (onClick)="refresh()"></dx-button>
import { Component } from "@angular/core"; import DataGrid from "devextreme/ui/data_grid"; // ... export class AppComponent { dataGridInstance: DataGrid; saveGridInstance (e) { this.dataGridInstance = e.component; } refresh() { this.dataGridInstance.refresh(); } }
Get a UI Component Instance
You can access a UI component instance in the component as described in Call Methods.
You can also use template reference variables to access a UI component instance in the markup:
<dx-select-box #targetSelectBox [items]="items"></dx-select-box> {{targetSelectBox.value}}
Data Layer
DevExtreme Data Layer is a set of components for working with data. Refer to the Data Layer API reference for code examples.
DevExtreme Validation Features
In the following example, two textboxes are placed in a validation group that is validated on a button click. Each textbox has a set of validation rules. The validation result is displayed under the textboxes in a validation summary.
<dx-validation-group> <dx-text-box [(value)]="email"> <dx-validator> <dxi-validation-rule type="required" message="Email is required"></dxi-validation-rule> <dxi-validation-rule type="email" message="Email is invalid"></dxi-validation-rule> </dx-validator> </dx-text-box> <dx-text-box [(value)]="password" mode="password"> <dx-validator> <dxi-validation-rule type="required" message="Password is required"></dxi-validation-rule> </dx-validator> </dx-text-box> <dx-validation-summary></dx-validation-summary> <dx-button (onClick)="validate($event)" text="Submit"></dx-button> </dx-validation-group>
// ... export class AppComponent { email: string; password: string; validate(params) { let result = params.validationGroup.validate(); if (result.isValid) { // the values are valid // submit and reset them // params.validationGroup.reset(); } } }
// ... import { DxTextBoxModule, DxValidatorModule, DxValidationSummaryModule, DxValidationGroupModule, DxButtonModule } from 'devextreme-angular'; @NgModule({ // ... imports: [ // ... DxTextBoxModule, DxValidatorModule, DxValidationSummaryModule, DxValidationGroupModule, DxButtonModule ] }) export class AppModule { }
Refer to the Data Validation article for more information.
Angular Forms Support
DevExtreme editors support the formControlName
directive needed for features of reactive forms...
<form [formGroup]="myForm"> <dx-text-box name="email" formControlName="email" [isValid]="emailControl.valid || emailControl.pristine" [validationError]="{ message: 'Email is invalid'}"> </dx-text-box> </form>
import { Component, OnInit } from '@angular/core'; import { FormGroup, FormControl, AbstractControl, Validators } from '@angular/forms'; // ... export class AppComponent implements OnInit { email: string; emailControl: AbstractControl; myForm: FormGroup; ngOnInit() { this.myForm = new FormGroup({ email: new FormControl('', Validators.compose([Validators.required, Validators.email])) }); this.emailControl = this.myForm.controls['email']; } }
// ... import { ReactiveFormsModule } from '@angular/forms'; import { DxTextBoxModule } from 'devextreme-angular'; @NgModule({ // ... imports: [ // ... DxTextBoxModule, ReactiveFormsModule ] }) export class AppModule { }
... and ngModel
binding necessary to use the editors in template-driven forms:
<form> <dx-text-box name="email" email required #emailControl="ngModel" [(ngModel)]="email" [isValid]="emailControl.valid || emailControl.pristine" [validationError]="{ message: 'Email is invalid'}"> </dx-text-box> </form>
// ... export class AppComponent { email: string; }
// ... import { FormsModule } from '@angular/forms'; import { DxTextBoxModule } from 'devextreme-angular'; @NgModule({ // ... imports: [ // ... DxTextBoxModule, FormsModule ] }) export class AppModule { }
Angular Change Detection Specifics
Angular activates change detection on each property change. This approach backfires when you try to pass functions to UI component properties that do not accept them. For example:
import { Component } from '@angular/core'; enum GridColumnsOption { PersonalDetails = 0, JobDetails = 1, } @Component({ selector: 'app-component', template: ` <dx-data-grid [columns]="getColumns(columnsOption)"> </dx-data-grid> `, }) export class AppComponent { columnsOption = GridColumnsOption.PersonalDetails; getColumns(option: GridColumnsOption): string[] { switch (option) { case GridColumnsOption.PersonalDetails: return [ 'name', 'address', 'phone', ]; case GridColumnsOption.JobDetails: return [ 'name', 'position', 'salary', ]; default: return []; } } }
In the code above, the getColumns()
function returns an array of objects, but this array is created from scratch each time the function is called. This is what happens when you run this code:
- The
getColumns()
function returns an array. - The array gets assigned to the
columns
property. This activates change detection. - When comparing the old and new
columns
values, the change detection mechanism callsgetColumns()
again and receives a different array. - The array gets assigned to the
columns
property, and the cycle repeats infinitely.
To work around this behavior, implement one of the following techniques:
Use a component’s class field instead of a method.
import { Component } from '@angular/core'; enum GridColumnsOption { PersonalDetails = 0, JobDetails = 1, } @Component({ selector: 'app-component', template: ` <dx-data-grid [columns]="columns[columnsOption]"> </dx-data-grid> `, }) export class AppComponent { columnsOption = GridColumnsOption.PersonalDetails; columns = { [GridColumnsOption.PersonalDetails]: [ 'name', 'address', 'phone', ], [GridColumnsOption.JobDetails]: [ 'name', 'position', 'salary', ], }; }
Rewrite a component’s class method to a custom Angular pipe.
import { Component, Pipe, PipeTransform, } from '@angular/core'; enum GridColumnsOption { PersonalDetails = 0, JobDetails = 1, } @Pipe({name: 'columnsPipe'}) export class ExponentialStrengthPipe implements PipeTransform { transform(columnsOption: GridColumnsOption): string[] { switch (option) { case GridColumnsOption.PersonalDetails: return [ 'name', 'address', 'phone', ]; case GridColumnsOption.JobDetails: return [ 'name', 'position', 'salary', ]; default: return []; } } } @Component({ selector: 'app-component', template: ` <dx-data-grid [columns]="columnsOption | columnsPipe"> </dx-data-grid> `, }) export class AppComponent { columnsOption = GridColumnsOption.PersonalDetails; }
Cache the return value of the component’s method (for example, you can use a universal apply pipe).
import { Component, Pipe, PipeTransform, } from '@angular/core'; enum GridColumnsOption { PersonalDetails = 0, JobDetails = 1, } @Pipe({ name: 'apply' }) export class ApplyPipe<TArgs, TReturn> implements PipeTransform { transform(func: ((...args: TArgs[]) => TReturn), ...args: TArgs[]): TReturn { return func(...args); } } @Component({ selector: 'app-component', template: ` <dx-data-grid [columns]="getColumns | apply: columnsOption"> </dx-data-grid> `, }) export class AppComponent { columnsOption = GridColumnsOption.PersonalDetails; getColumns = (option: GridColumnsOption): string[] => { switch (option) { case GridColumnsOption.PersonalDetails: return [ 'name', 'address', 'phone', ]; case GridColumnsOption.JobDetails: return [ 'firstName', 'position', 'salary', ]; default: return []; } } }
If you have technical questions, please create a support ticket in the DevExpress Support Center.

DevExtreme React - Component Configuration Syntax

To help you configure DevExtreme UI components in a React-style code structure, we implemented configuration components. These are elements nested in JSX code as if they represented a UI component's sub-elements, but from the technical point of view, they only carry the configuration data. This means that UI component properties can be supplied declaratively and selectively, with default fallbacks in place.

Static Property Value

Function component
Class component
  • import Button from 'devextreme-react/button';
  •  
  • export default function App() {
  • return (
  • <Button
  • disabled={false}
  • width={50}
  • text="Click me"
  • />
  • );
  • }
  • import Button from 'devextreme-react/button';
  •  
  • class App extends React.Component {
  • render() {
  • return (
  • <Button
  • disabled={false}
  • width={50}
  • text="Click me"
  • />
  • );
  • }
  • }

Properties of the Object Type

Use nested configuration components. In the following example, we configure the Chart UI component's tooltip property:

Function component
Class component
  • import Chart, {
  • Tooltip
  • } from 'devextreme-react/chart';
  •  
  • export default function App() {
  • return (
  • <Chart>
  • <Tooltip
  • enabled={true}
  • format="thousands"
  • />
  • </Chart>
  • );
  • }
  • import Chart, {
  • Tooltip
  • } from 'devextreme-react/chart';
  •  
  • class App extends React.Component {
  • render() {
  • return (
  • <Chart>
  • <Tooltip
  • enabled={true}
  • format="thousands"
  • />
  • </Chart>
  • );
  • }
  • }

Object type properties that depend on other properties' values are not implemented as nested configuration components because they cannot be typed (columns[].editorOptions in the DataGrid, item's editorOptions in the Form, items[].options in the Toolbar). These properties should be specified with an object.

Function component
Class component
  • import DataGrid, {
  • Column
  • } from 'devextreme-react/data-grid';
  •  
  • const columnEditorOptions = { width: 100 };
  •  
  • export default function App() {
  • return (
  • <DataGrid>
  • <Column
  • editorOptions={columnEditorOptions}
  • />
  • </DataGrid>
  • );
  • }
  • import DataGrid, {
  • Column
  • } from 'devextreme-react/data-grid';
  •  
  • class App extends React.Component {
  • columnEditorOptions = { width: 100 };
  •  
  • render() {
  • return (
  • <DataGrid>
  • <Column
  • editorOptions={this.columnEditorOptions}
  • />
  • </DataGrid>
  • );
  • }
  • }
IMPORTANT
We recommend that you declare the object outside the configuration component to prevent possible issues caused by unnecessary re-rendering.

If you use React Hooks and need to define a configuration object inside a function component, wrap this object in the useMemo hook to preserve the object's reference between state changes:

App.js
  • import React, { useState, useMemo } from 'react';
  • import Form, { Label, SimpleItem } from 'devextreme-react/form';
  •  
  • const data = { isAddressRequired: false, Address: '' };
  •  
  • export default function App() {
  • const [visible, setVisible] = useState(false);
  • const checkBoxOptions = useMemo(() => {
  • return {
  • text: "Display Address",
  • onValueChanged: (e) => {
  • setVisible(e.value);
  • }
  • }
  • }, []);
  • const addressOptions = useMemo(() => {
  • return {
  • placeholder: 'Enter your addresss',
  • maxLength: 50
  • }
  • }, []);
  •  
  • return (
  • <Form formData={data}
  • width={400}>
  • <SimpleItem
  • dataField="isAddressRequired"
  • editorType="dxCheckBox"
  • editorOptions={checkBoxOptions}>
  • <Label visible={false} />
  • </SimpleItem>
  • <SimpleItem
  • dataField="Address"
  • editorType="dxTextBox"
  • editorOptions={addressOptions}
  • visible={visible}
  • />
  • </Form>
  • );
  • }

Collections

Use nested configuration components. The following example shows how to configure the DataGrid's columns property:

Function component
Class component
  • import DataGrid, {
  • Column
  • } from 'devextreme-react/data-grid';
  •  
  • export default function App() {
  • return (
  • <DataGrid>
  • <Column
  • dataField="firstName"
  • caption="First Name"
  • />
  • <Column
  • dataField="lastName"
  • caption="Last Name"
  • defaultVisible={true}
  • />
  • </DataGrid>
  • );
  • }
  • import DataGrid, {
  • Column
  • } from 'devextreme-react/data-grid';
  •  
  • class App extends React.Component {
  • render() {
  • return (
  • <DataGrid>
  • <Column
  • dataField="firstName"
  • caption="First Name"
  • />
  • <Column
  • dataField="lastName"
  • caption="Last Name"
  • defaultVisible={true}
  • />
  • </DataGrid>
  • );
  • }
  • }

DevExtreme collection UI components also support the Item element. It allows you to declare collection items in the UI component markup. An Item element can contain custom markup and have properties that control parts of item appearance, such as badge in the following code. The properties are described in the items section of each collection UI component.

Function component
Class component
  • import List, {
  • Item
  • } from 'devextreme-react/list';
  •  
  • export default function App() {
  • return (
  • <List>
  • <Item>Orange</Item>
  • <Item badge="New">White</Item>
  • <Item>Black</Item>
  • </List>
  • );
  • }
  • import List, {
  • Item
  • } from 'devextreme-react/list';
  •  
  • class App extends React.Component {
  • render() {
  • return (
  • <List>
  • <Item>Orange</Item>
  • <Item badge="New">White</Item>
  • <Item>Black</Item>
  • </List>
  • );
  • }
  • }

Event Handling

Function component
Class component
  • import { useCallback } from 'react';
  • import Button from 'devextreme-react/button';
  •  
  • export default function App() {
  • const handleButtonClick = useCallback((e) => {
  • alert("The button was clicked")
  • }, []);
  •  
  • return (
  • <Button
  • onClick={handleButtonClick}
  • />
  • );
  • }
  • import Button from 'devextreme-react/button';
  •  
  • class App extends React.Component {
  • constructor(props) {
  • super(props);
  • // Uncomment the line below to bind the handler to the React component's context, for example, to call this.setState()
  • // this.handleButtonClick = this.handleButtonClick.bind(this);
  • }
  •  
  • render() {
  • return (
  • <Button
  • onClick={this.handleButtonClick}
  • />
  • );
  • }
  •  
  • handleButtonClick(e) {
  • alert("The button was clicked")
  • }
  • }
IMPORTANT
In function components, wrap the event handler declaration into the useCallback React Hook to prevent possible issues caused by unnecessary re-rendering.

Callback Functions

Function component
Class component
  • import { useCallback } from 'react';
  • import VectorMap, { Layer } from 'devextreme-react/vector-map';
  •  
  • export default function App() {
  • const customizeLayers = useCallback((elements) => {
  • // ...
  • }, []);
  •  
  • return (
  • <VectorMap>
  • <Layer
  • customize={customizeLayers}
  • />
  • </VectorMap>
  • );
  • }
  • import VectorMap, { Layer } from 'devextreme-react/vector-map';
  •  
  • class App extends React.Component {
  • render() {
  • return (
  • <VectorMap>
  • <Layer
  • customize={this.customizeLayers}
  • />
  • </VectorMap>
  • );
  • }
  •  
  • customizeLayers(elements) {
  • // ...
  • }
  • }
IMPORTANT
In function components, wrap the callback function declaration into the useCallback React Hook to prevent possible issues caused by unnecessary re-rendering.

In class components, callback functions are executed outside the React component's context. If the context is important, explicitly bind the callback function to it in the constructor.

Class component
  • class App extends React.Component {
  • myCountry: string = 'USA'; // we need to access this context variable in the callback function
  •  
  • constructor(props) {
  • super(props);
  • this.customizeLayers = this.customizeLayers.bind(this);
  • }
  •  
  • customizeLayers(elements) {
  • let country = this.myCountry;
  • // ...
  • }
  • // ...
  • }

Declare Content in the Markup

The following UI components allow you to declare their content directly in the markup:

The following is an example with ScrollView:

Function component
Class component
  • import ScrollView from 'devextreme-react/scroll-view';
  •  
  • export default function App() {
  • return (
  • <ScrollView>
  • <div>Some scrollable content</div>
  • </ScrollView>
  • );
  • }
  • import ScrollView from 'devextreme-react/scroll-view';
  •  
  • class App extends React.Component {
  • render() {
  • return (
  • <ScrollView>
  • <div>Some scrollable content</div>
  • </ScrollView>
  • );
  • }
  • }
IMPORTANT

These UI components do not support dynamically or conditionally rendered content in their root element. For example, the following code does not work:

App.js
  • <Drawer ... >
  • {
  • someCondition && <div> ... </div>
  • // when the condition changes in runtime, the UI component may not render content correctly
  • }
  • </Drawer>

Wrap the content in a static element:

App.js
  • <Drawer ... >
  • <div>
  • {
  • someCondition && <div> ... </div>
  • }
  • </div>
  • </Drawer>

Note that React.Fragment is a dynamically rendered element and doesn't fit in this case. Use static elements such as div or span instead.

Markup Customization

Templates allow you to customize UI components. In the DevExtreme API, template properties end with Template: itemTemplate, groupTemplate, contentTemplate. When you specify them in React, replace Template in the name with Render or Component, depending on whether the template is a rendering function or custom component. For example, instead of itemTemplate, use itemRender or itemComponent. If a component does not reinitiate a template when the component rerenders, you should use the itemComponent property. Otherwise, we recommend that you use the itemRender property.

If the property is called template, without any prefix, (in the Button, Drawer, and other UI components), use the render or component property instead.

Using a Rendering Function

In the following code, rendering functions are used to specify the List's itemTemplate and the Button's template:

Function component
Class component
  • import List from 'devextreme-react/list';
  • import Button from 'devextreme-react/button';
  •  
  • const renderListItem = (itemData) => {
  • return <p>{itemData.itemProperty}</p>;
  • }
  • const renderButton = (button) => {
  • return <div style={{ padding: 20 }}><p>{button.text}</p></div>;
  • }
  •  
  • export default function App() {
  • return (
  • <React.Fragment>
  • <List itemRender={renderListItem} />
  • <Button render={renderButton} />
  • </React.Fragment>
  • );
  • }
  • import List from 'devextreme-react/list';
  • import Button from 'devextreme-react/button';
  •  
  • const renderListItem = (itemData) => {
  • return <p>{itemData.itemProperty}</p>;
  • }
  • const renderButton = (button) => {
  • return <div style={{ padding: 20 }}><p>{button.text}</p></div>;
  • }
  • class App extends React.Component {
  • render() {
  • return (
  • <React.Fragment>
  • <List itemRender={renderListItem} />
  • <Button render={renderButton} />
  • </React.Fragment>
  • );
  • }
  • }

Using a Custom Component

You can define the template markup in a separate component. We recommend using React.PureComponent because React.Component can be re-rendered unnecessarily. Alternatively, you can implement the shouldComponentUpdate() method.

In the following code, custom components are used to specify the List's itemTemplate and the Button's template. Template variables are passed to the components as props.

Class component
  • import List from 'devextreme-react/list';
  • import Button from 'devextreme-react/button';
  •  
  • class ListItemTmpl extends React.PureComponent {
  • render() {
  • return (
  • <p>{this.props.data.itemProperty}</p>
  • );
  • }
  • }
  •  
  • class ButtonTmpl extends React.PureComponent {
  • render() {
  • return (
  • <div style={{ padding: 20 }}>
  • <p>{this.props.data.text}</p>
  • </div>
  • );
  • }
  • }
  •  
  • class App extends React.Component {
  • render() {
  • return (
  • <React.Fragment>
  • <List itemComponent={ListItemTmpl} />
  • <Button component={ButtonTmpl} />
  • </React.Fragment>
  • );
  • }
  • }

Using the Template Component

Several properties are not implemented as nested configuration components (columns[].editorOptions in the DataGrid, item's editorOptions in the Form, items[].options in the Toolbar). These properties do not have the render or component property to which you would pass your rendering function or custom component. However, you can still customize the markup — using the Template element.

The Template element declares a named template. Its name property should be assigned to a ...Template property of the UI component that uses the Template. The template's markup can be specified as follows:

  • Rendering function
    Pass the rendering function to the Template's render property:

    Function component
    Class component
    data.js
    • import Form, { Item } from 'devextreme-react/form';
    • import { Template } from 'devextreme-react/core/template';
    •  
    • import service from './data.js';
    •  
    • const renderSelectBoxItem = (item) => {
    • return <div>{item.toUpperCase()}</div>;
    • }
    • const employee = service.getEmployee();
    • const positions = service.getPositions();
    • const positionEditorOptions = {
    • items: positions,
    • value: '',
    • itemTemplate: 'selectBoxItem'
    • };
    •  
    • export default function App() {
    • return (
    • <Form formData={employee}>
    • <Item
    • dataField="Position"
    • editorType="dxSelectBox"
    • editorOptions={positionEditorOptions}
    • />
    • <Template name="selectBoxItem" render={renderSelectBoxItem} />
    • </Form>
    • );
    • }
    • import Form, { Item } from 'devextreme-react/form';
    • import { Template } from 'devextreme-react/core/template';
    •  
    • import service from './data.js';
    •  
    • const renderSelectBoxItem = item => {
    • return <div>{item.toUpperCase()}</div>;
    • }
    •  
    • class App extends React.Component {
    • constructor(props) {
    • super(props);
    • this.employee = service.getEmployee();
    • this.positions = service.getPositions();
    • this.positionEditorOptions = {
    • items: this.positions,
    • value: '',
    • itemTemplate: 'selectBoxItem'
    • };
    • }
    • render() {
    • return (
    • <Form formData={this.employee}>
    • <Item
    • dataField="Position"
    • editorType="dxSelectBox"
    • editorOptions={this.positionEditorOptions}
    • />
    • <Template name="selectBoxItem" render={renderSelectBoxItem} />
    • </Form>
    • );
    • }
    • }
    • export default App;
    • const employee = {
    • ID: 1,
    • FirstName: 'John',
    • LastName: 'Heart',
    • Position: 'CEO',
    • BirthDate: '1964/03/16',
    • HireDate: '1995/01/15',
    • Address: '351 S Hill St., Los Angeles, CA',
    • Phone: '360-684-1334',
    • Email: 'jheart@dx-email.com'
    • };
    •  
    • const positions = [
    • 'HR Manager',
    • 'IT Manager',
    • 'CEO',
    • 'Controller',
    • 'Sales Manager',
    • 'Support Manager',
    • 'Shipping Manager'
    • ];
    •  
    • export default {
    • getEmployee() {
    • return employee;
    • },
    • getPositions() {
    • return positions;
    • }
    • }
  • Custom component
    Assign the custom component to the Template's component property:

    Class component
    data.js
    • import Form, { Item } from 'devextreme-react/form';
    • import { Template } from 'devextreme-react/core/template';
    •  
    • import service from './data.js';
    •  
    • class SelectBoxItemTmpl extends React.PureComponent {
    • render() {
    • return (
    • <div>{this.props.data.toUpperCase()}</div>
    • );
    • }
    • }
    •  
    • class App extends React.Component {
    • constructor(props) {
    • super(props);
    • this.employee = service.getEmployee();
    • this.positions = service.getPositions();
    • this.positionEditorOptions = {
    • items: this.positions,
    • value: '',
    • itemTemplate: 'selectBoxItem'
    • };
    • }
    • render() {
    • return (
    • <Form formData={this.employee}>
    • <Item
    • dataField="Position"
    • editorType="dxSelectBox"
    • editorOptions={this.positionEditorOptions}
    • />
    • <Template name="selectBoxItem" component={SelectBoxItemTmpl} />
    • </Form>
    • );
    • }
    • }
    • export default App;
    • const employee = {
    • ID: 1,
    • FirstName: 'John',
    • LastName: 'Heart',
    • Position: 'CEO',
    • BirthDate: '1964/03/16',
    • HireDate: '1995/01/15',
    • Address: '351 S Hill St., Los Angeles, CA',
    • Phone: '360-684-1334',
    • Email: 'jheart@dx-email.com'
    • };
    •  
    • const positions = [
    • 'HR Manager',
    • 'IT Manager',
    • 'CEO',
    • 'Controller',
    • 'Sales Manager',
    • 'Support Manager',
    • 'Shipping Manager'
    • ];
    •  
    • export default {
    • getEmployee() {
    • return employee;
    • },
    • getPositions() {
    • return positions;
    • }
    • }

Call Methods

To call UI component methods, you need the UI component instance. Create a ref and attach it to the target component via the ref property. In the following code, this approach is used to get a TextBox instance:

Function component
Class component
  • import React, { useRef, useCallback } from 'react';
  • import Button from 'devextreme-react/button';
  • import TextBox from 'devextreme-react/text-box';
  •  
  • export default function App() {
  • const textBox = useRef(null);
  • const focusTextBox = useCallback(() => {
  • // `current.instance` points to the UI component instance
  • textBox.current.instance.focus();
  • }, []);
  •  
  • return (
  • <div>
  • <TextBox ref={textBox} />
  • <Button text="Focus TextBox" onClick={focusTextBox} />
  • </div>
  • );
  • }
  • import Button from 'devextreme-react/button';
  • import TextBox from 'devextreme-react/text-box';
  •  
  • class App extends React.Component {
  • constructor(props) {
  • super(props);
  •  
  • this.textBoxRef = React.createRef();
  •  
  • this.focusTextBox = () => {
  • this.textBox.focus()
  • };
  • }
  •  
  • get textBox() {
  • // `current.instance` points to the UI component instance
  • return this.textBoxRef.current.instance;
  • }
  •  
  • render() {
  • return (
  • <div>
  • <TextBox ref={this.textBoxRef} />
  • <Button text="Focus TextBox" onClick={this.focusTextBox} />
  • </div>
  • );
  • }
  • }

Alternatively, you can assign the UI component instance to a variable and use it to call the methods. This approach is not compatible with React Hooks.

Class component
  • import Button from 'devextreme-react/button';
  • import TextBox from 'devextreme-react/text-box';
  •  
  • class App extends React.Component {
  • constructor(props) {
  • super(props);
  •  
  • this.saveTextBoxInstance = this.saveTextBoxInstance.bind(this);
  • this.focusTextBox = this.focusTextBox.bind(this);
  • }
  •  
  • saveTextBoxInstance(e) {
  • this.textBoxInstance = e.component;
  • }
  •  
  • focusTextBox() {
  • this.textBoxInstance.focus();
  • }
  •  
  • render() {
  • return (
  • <div>
  • <TextBox onInitialized={this.saveTextBoxInstance} />
  • <Button text="Focus TextBox" onClick={this.focusTextBox} />
  • </div>
  • );
  • }
  • }

Get a UI Component Instance

For information on this matter, refer to Call Methods.

Data Layer

DevExtreme Data Layer is a set of components for working with data. The following example shows how to use the DataSource component with the List UI component:

Function component
Class component
  • import React, { useEffect } from 'react';
  • import DataSource from 'devextreme/data/data_source';
  • import List from 'devextreme-react/list';
  •  
  • const items = [
  • { text: '123' },
  • { text: '234' },
  • { text: '567' }
  • ];
  • const dataSource = new DataSource({
  • store: {
  • type: "array",
  • data: items
  • },
  • sort: { getter: "text", desc: true }
  • });
  •  
  • export default function App() {
  • useEffect(() => {
  • // A DataSource instance created outside a UI component should be disposed of manually.
  • return () => { dataSource.dispose(); }
  • });
  • return (
  • <List dataSource={dataSource} />
  • );
  • }
  • import DataSource from 'devextreme/data/data_source';
  • import List from 'devextreme-react/list';
  •  
  • const items = [
  • { text: '123' },
  • { text: '234' },
  • { text: '567' }
  • ];
  •  
  • class Example extends React.Component {
  • constructor(props) {
  • super(props);
  •  
  • this.dataSource = new DataSource({
  • store: {
  • type: 'array',
  • data: items
  • },
  • sort: { getter: 'text', desc: true }
  • });
  • }
  •  
  • render() {
  • return (
  • <List dataSource={this.dataSource} />
  • );
  • }
  •  
  • componentWillUnmount() {
  • // A DataSource instance created outside a UI component should be disposed of manually.
  • this.dataSource.dispose();
  • }
  • }
NOTE
When a data layer component's properties are modified, the bound UI component is not re-rendered.

DevExtreme Validation Features

In the following example, two textboxes are placed in a validation group that is validated on a button click. Each textbox has a set of validation rules. The validation result is displayed under the textboxes in a validation summary.

Function component
Class component
  • import React, { useState, useCallback } from 'react';
  • import TextBox from 'devextreme-react/text-box';
  • import Validator, { RequiredRule, EmailRule } from 'devextreme-react/validator';
  • import ValidationGroup from 'devextreme-react/validation-group';
  • import Button from 'devextreme-react/button';
  •  
  • export default function App() {
  • const [email, setEmail] = useState(null);
  • const [password, setPassword] = useState(null);
  • const validate = useCallback((params) => {
  • const result = params.validationGroup.validate();
  • if (result.isValid) {
  • // The values are valid
  • // Submit them...
  • // ...
  • // ... and then reset
  • // params.validationGroup.reset();
  • }
  • }, []);
  • const handleEmailChange = useCallback((e) => {
  • setEmail(e.value);
  • }, []);
  • const handlePasswordChange = useCallback((e) => {
  • setPassword(e.value);
  • }, []);
  •  
  • return (
  • <ValidationGroup>
  • <TextBox value={email} onValueChanged={handleEmailChange}>
  • <Validator>
  • <RequiredRule message="Email is required" />
  • <EmailRule message="Email is invalid" />
  • </Validator>
  • </TextBox>
  •  
  • <TextBox value={password} mode="password" onValueChanged={handlePasswordChange}>
  • <Validator>
  • <RequiredRule message="Password is required" />
  • </Validator>
  • </TextBox>
  • <Button onClick={validate} text="Submit" />
  • </ValidationGroup>
  • );
  • }
  • import TextBox from 'devextreme-react/text-box';
  • import Validator, { RequiredRule, EmailRule } from 'devextreme-react/validator';
  • import ValidationGroup from 'devextreme-react/validation-group';
  • import Button from 'devextreme-react/button';
  •  
  • class App extends React.Component {
  • constructor(props) {
  • super(props);
  • this.state = {
  • email: null,
  • password: null
  • };
  • this.handleEmailChange = (e) => {
  • this.setState({
  • email: e.value
  • });
  • };
  • this.handlePasswordChange = (e) => {
  • this.setState({
  • password: e.value
  • });
  • };
  • this.validate = this.validate.bind(this);
  • }
  •  
  • render() {
  • return (
  • <ValidationGroup>
  • <TextBox value={this.state.email} onValueChanged={this.handleEmailChange}>
  • <Validator>
  • <RequiredRule message="Email is required" />
  • <EmailRule message="Email is invalid" />
  • </Validator>
  • </TextBox>
  •  
  • <TextBox value={this.state.password} mode="password" onValueChanged={this.handlePasswordChange}>
  • <Validator>
  • <RequiredRule message="Password is required" />
  • </Validator>
  • </TextBox>
  • <Button onClick={this.validate} text="Submit" />
  • </ValidationGroup>
  • );
  • }
  •  
  • validate(params) {
  • const result = params.validationGroup.validate();
  • if (result.isValid) {
  • // The values are valid
  • // Submit them...
  • // ...
  • // ... and then reset
  • // params.validationGroup.reset();
  • }
  • }
  • }

Refer to the Data Validation article for more information.

DevExtreme Vue - Component Configuration Syntax

Static String Property Value

HTML
  • <DxButton text="Simple button" />

Static Non-String Property Value

HTML
  • <DxButton
  • :disabled="false"
  • :width="50"
  • />

Properties of the Object Type

Use nested configuration components. In the following example, we configure the Chart's tooltip property:

App.vue
  • <template>
  • <DxChart>
  • <DxTooltip
  • :enabled="true"
  • format="thousands"
  • />
  • </DxChart>
  • </template>
  •  
  • <script>
  • import DxChart, {
  • DxTooltip
  • } from 'devextreme-vue/chart';
  •  
  • export default {
  • components: {
  • DxChart,
  • DxTooltip
  • }
  • }
  • </script>

Object type properties that depend on other properties' values are not implemented as nested configuration components because they cannot be typed (columns[].editorOptions in the DataGrid, item's editorOptions in the Form, items[].options in the Toolbar). These properties should be specified with an object.

App.vue
  • <template>
  • <DxDataGrid>
  • <DxColumn
  • :editor-options="columnEditorOptions"
  • />
  • </DxDataGrid>
  • </template>
  •  
  • <script>
  • import DxDataGrid, {
  • DxColumn
  • } from 'devextreme-vue/data-grid';
  •  
  • export default {
  • components: {
  • DxDataGrid,
  • DxColumn
  • },
  • data() {
  • return {
  • columnEditorOptions: { width: 100 }
  • }
  • }
  • }
  • </script>
IMPORTANT
We recommend that you declare the object outside the configuration component to prevent possible issues caused by unnecessary re-rendering.

Collections

Use nested configuration components. The following example shows how to configure the DataGrid's columns property:

App.vue
  • <template>
  • <DxDataGrid>
  • <DxColumn
  • data-field="firstName"
  • caption="Name"
  • />
  • <DxColumn
  • data-field="lastName"
  • caption="Surname"
  • />
  • </DxDataGrid>
  • </template>
  •  
  • <script>
  • import DxDataGrid, {
  • DxColumn
  • } from 'devextreme-vue/data-grid';
  •  
  • export default {
  • components: {
  • DxDataGrid,
  • DxColumn
  • }
  • }
  • </script>

DevExtreme collection UI components also support the DxItem element. It allows you to declare collection items in the UI component markup. DxItem can contain custom markup and have attributes that control parts of item appearance, such as badge in the following code. The attributes are described in the items section of each collection UI component. Ensure to specify that an item's content is in the default slot.

App.vue
  • <template>
  • <DxList>
  • <DxItem>
  • <template #default>
  • Orange
  • </template>
  • </DxItem>
  • <DxItem badge="New">
  • <template #default>
  • White
  • </template>
  • </DxItem>
  • <DxItem>
  • <template #default>
  • Black
  • </template>
  • </DxItem>
  • </DxList>
  • </template>
  •  
  • <script>
  • import DxList, {
  • DxItem
  • } from 'devextreme-vue/list';
  •  
  • export default {
  • components: {
  • DxList,
  • DxItem
  • }
  • }
  • </script>

DxItem also supports structural directives provided by Vue, such as v-for:

App.vue
  • <template>
  • <DxList>
  • <DxItem>
  • <template #default>
  • <h1>Available items</h1>
  • </template>
  • </DxItem>
  • <DxItem
  • v-for="item in listItems"
  • :key="item.text"
  • :badge="item.badge">
  • <template #default>
  • {{ item.text }}
  • </template>
  • </DxItem>
  • </DxList>
  • </template>
  •  
  • <script>
  • import DxList, {
  • DxItem
  • } from 'devextreme-vue/list';
  •  
  • export default {
  • components: {
  • DxList,
  • DxItem
  • },
  • data() {
  • return {
  • listItems: [{
  • text: 'Cars',
  • badge: '12'
  • }, {
  • text: 'Bikes',
  • badge: '5'
  • }]
  • }
  • }
  • }
  • </script>

Event Handling

App.vue
  • <template>
  • <DxButton
  • text="OK"
  • @click="okClicked"
  • />
  • </template>
  •  
  • <script>
  • import DxButton from 'devextreme-vue/button';
  • import notify from 'devextreme/ui/notify';
  •  
  • export default {
  • components: {
  • DxButton
  • },
  • methods: {
  • okClicked: function(e) {
  • notify('The OK button was clicked')
  • }
  • }
  • }
  • </script>

Callback Functions

App.vue
  • <template>
  • <DxVectorMap>
  • <DxLayer :customize="customizeLayers" />
  • </DxVectorMap>
  • </template>
  •  
  • <script>
  • import DxVectorMap, {
  • DxLayer
  • } from 'devextreme-vue/vector-map';
  •  
  • export default {
  • components: {
  • DxVectorMap,
  • DxLayer
  • },
  • methods: {
  • customizeLayers(elements) {
  • // ...
  • }
  • }
  • }
  • </script>

One-Way Property Binding

Changes in the bindingProperty are propagated to the TextBox's value, but not vice versa:

App.vue
  • <template>
  • <DxTextBox :value="bindingProperty" />
  • </template>
  •  
  • <script>
  • import DxTextBox from 'devextreme-vue/text-box';
  •  
  • export default {
  • components: {
  • DxTextBox
  • },
  • data() {
  • return {
  • bindingProperty: 'Some value'
  • }
  • }
  • }
  • </script>

Two-Way Property Binding

Changes in the bindingProperty are propagated to the TextBox's value and vice versa:

App.vue
  • <template>
  • <DxTextBox v-model:value="bindingProperty" />
  • </template>
  •  
  • <script>
  • import DxTextBox from 'devextreme-vue/text-box';
  •  
  • export default {
  • components: {
  • DxTextBox
  • },
  • data() {
  • return {
  • bindingProperty: 'Some value'
  • }
  • }
  • }
  • </script>

Declare Content in the Markup

The following UI components allow you to declare their content directly in the markup:

The following is an example with ScrollView:

App.vue
  • <template>
  • <DxScrollView>
  • <div>Some scrollable content</div>
  • </DxScrollView>
  • </template>
  •  
  • <script>
  • import DxScrollView from 'devextreme-vue/scroll-view';
  •  
  • export default {
  • components: {
  • DxScrollView
  • }
  • }
  • </script>
IMPORTANT

These UI components do not support dynamically or conditionally rendered content in their root element. For example, the following code does not work:

App.vue
  • <template>
  • <DxDrawer ... >
  • <router-view></router-view>
  • </DxDrawer>
  • </template>

Wrap the content in a static element:

App.vue
  • <template>
  • <DxDrawer ... >
  • <div>
  • <router-view></router-view>
  • </div>
  • </DxDrawer>
  • </template>

Templates

Templates allow you to customize UI components. DevExtreme templates make use of the named slots functionality provided by Vue.

In the following code, an itemTemplate called list-item and a groupTemplate called list-group customize items and groups in the List UI component. The data slot prop exposes the item or group data object; the index slot prop gives access to the item index.

App.vue
  • <template>
  • <DxList
  • :items="groupedItems"
  • :grouped="true"
  • item-template="list-item"
  • group-template="list-group">
  • <template #list-item="{ data, index }">
  • {{ index }} - {{ data.itemProperty }}
  • </template>
  • <template #list-group="{ data }">
  • {{ data.groupProperty }}
  • </template>
  • </DxList>
  • </template>
  •  
  • <script>
  • import DxList from 'devextreme-vue/list';
  •  
  • export default {
  • components: {
  • DxList
  • },
  • data() {
  • return {
  • groupedItems: [ /* ... */ ]
  • }
  • }
  • }
  • </script>
IMPORTANT
In Vue 2 applications, a<template> should not contain more than one root element. Vue 3 applications have no restriction.

Refer to the common Custom Templates article for more information.

Call Methods

To call UI component methods, you need the UI component instance. Define its key in the ref attribute. Then, pass the key to the $refs property to get the component. The UI component instance is stored in the component's instance field:

App.vue
  • <template>
  • <div>
  • <DxTextBox :ref="textBoxRefKey" />
  • <DxButton text="Focus TextBox" @click="focusTextBox" />
  • </div>
  • </template>
  •  
  • <script>
  • import DxButton from 'devextreme-vue/button';
  • import DxTextBox from 'devextreme-vue/text-box';
  •  
  • const textBoxRefKey = "my-text-box";
  •  
  • export default {
  • components: {
  • DxTextBox,
  • DxButton
  • },
  • data: function() {
  • return {
  • textBoxRefKey
  • };
  • },
  • methods: {
  • focusTextBox: function() {
  • this.textBox.focus();
  • }
  • },
  • computed: {
  • textBox: function() {
  • return this.$refs[textBoxRefKey].instance;
  • }
  • }
  • };
  • </script>

Alternatively, you can assign the UI component instance to a variable and use it to call the methods:

App.vue
  • <template>
  • <div>
  • <DxDataGrid ...
  • @initialized="saveGridInstance">
  • </DxDataGrid>
  • <DxButton text="Refresh data" @click="refresh"/>
  • </div>
  • </template>
  •  
  • <script>
  • import DxDataGrid from 'devextreme-vue/data-grid';
  • import DxButton from 'devextreme-vue/button';
  •  
  • export default {
  • components: {
  • DxDataGrid,
  • DxButton
  • },
  • data: function() {
  • return {
  • dataGridInstance: null
  • };
  • },
  • methods: {
  • saveGridInstance: function(e) {
  • this.dataGridInstance = e.component;
  • },
  • refresh: function() {
  • this.dataGridInstance.refresh();
  • }
  • }
  • };
  • </script>

Get a UI Component Instance

For information on this matter, refer to Call Methods.

Data Layer

DevExtreme Data Layer is a set of components for working with data. Refer to the Data Layer API reference for code examples.

DevExtreme Validation Features

In the following example, two textboxes are placed in a validation group that is validated on a button click. Each textbox has a set of validation rules. The validation result is displayed under the textboxes in a validation summary.

App.vue
  • <template>
  • <DxValidationGroup>
  • <DxTextBox v-model:value="email">
  • <DxValidator>
  • <DxRequiredRule message="Email is required" />
  • <DxEmailRule message="Email is invalid" />
  • </DxValidator>
  • </DxTextBox>
  •  
  • <DxTextBox v-model:value="password" mode="password">
  • <DxValidator>
  • <DxRequiredRule message="Password is required" />
  • </DxValidator>
  • </DxTextBox>
  •  
  • <DxValidationSummary />
  •  
  • <DxButton @click="validate" text="Submit" />
  • </DxValidationGroup>
  • </template>
  •  
  • <script>
  • import DxTextBox from 'devextreme-vue/text-box';
  • import DxValidator, {
  • DxRequiredRule,
  • DxEmailRule
  • } from 'devextreme-vue/validator';
  • import DxValidationGroup from 'devextreme-vue/validation-group';
  • import DxValidationSummary from 'devextreme-vue/validation-summary';
  • import DxButton from 'devextreme-vue/button';
  •  
  • export default {
  • components: {
  • DxTextBox,
  • DxValidator,
  • DxRequiredRule,
  • DxEmailRule,
  • DxValidationGroup,
  • DxValidationSummary,
  • DxButton
  • },
  • data() {
  • return {
  • email: undefined,
  • password: undefined
  • }
  • },
  • methods: {
  • validate(params) {
  • let result = params.validationGroup.validate();
  • if (result.isValid) {
  • // the values are valid
  • // submit and reset them
  • // params.validationGroup.reset();
  • console.log(result);
  • }
  • }
  • }
  • }
  • </script>

Refer to the Data Validation article for more information.

Vue Form Input Bindings Support

DevExtreme editors support the v-model directive that creates two-way binding on the editor's value.

App.vue
  • <template>
  • <DxTextBox v-model="bindingProperty" />
  • </template>
  •  
  • <script>
  • import DxTextBox from 'devextreme-vue/text-box';
  •  
  • export default {
  • components: {
  • DxTextBox
  • },
  • data() {
  • return {
  • bindingProperty: 'Some value'
  • }
  • }
  • }
  • </script>

Alternatively, you can use the sync modifier.